﻿using CommonHelper;
using PmsSecondaryPackaging.Interface.Model.Carrier;
using PmsSecondaryPackaging.Interface.Model.StepBook;
using PmsSecondaryPackaging.Interface.Model.TaskBook;
using PmsSecondaryPackaging.TaskManager.TaskBookBehavior;
using ProjectManagementSystem.Config;
using System.Collections.Generic;
using System.Data;
using System.Threading;
using System.Data.SqlClient;
using MaxCommunication.DataBase.Document;

namespace ProjectManagementSystem.TaskBookEvent
{
    public class TaskBookBehavior_65053 : BaseTaskBookBehavior
    {
        ////////////////////
        /// 获取下料点，更改库位状态为锁定（目前不用，一开始的时候就确定库位）
        ////////////////////
        public TaskBookBehavior_65053() : base(65053)
        {

        }

        public override bool TaskBookOperator(TaskDetailInfoModel taskDetailInfo, List<StepDetailInfoModel> taskStepInfoList, CarrierInfoModel carrierInfo)
        {

            
            try
            {
                //判断是否是pad调度任务，是的话不变更下料点
                bool result = JudgeIsPadTask(taskDetailInfo.TaskID);
                if (result)
                    return result;


                //获取下料点
                //成功，更改相关库位信息
                //失败，再循环获取
                //获取库位信息
                string wareHouse = string.Empty;
                DBHelper.connString = CConfiManager.customConfig.ConnectString;
                SqlParameter[] parameters = new SqlParameter[]
                {
                new SqlParameter("@taskID",taskDetailInfo.TaskID)
                };
                while (true)
                {
                    //获取到库位时已经锁定库位
                    DataTable dt = DBHelper.ExecuteSelect("hp_GetFreeWarehouse", true, parameters);
                    wareHouse = dt.Rows[0][0].ToString();
                    if (!string.IsNullOrEmpty(wareHouse))
                        break;
                    Thread.Sleep(800);
                }
                //更改流程的下料点
                int currentStepID = taskDetailInfo.CurrentStepID;
                List<StepDetailInfoModel> list = taskStepInfoList.FindAll(p => p.StepId > currentStepID);
                int tmpCount = 0;
                foreach (StepDetailInfoModel item in list)
                {
                    StepUpdateWareHouseInfoModel model = new StepUpdateWareHouseInfoModel(taskDetailInfo.TaskID, item.StepId, wareHouse);
                    string message = string.Empty;
                    if (!InterfaceService.UpdateStepWarehouse(model, out message))
                    {
                        TextDocument.WriteFile(@"PMS/Log", "TaskError_", message);
                    }
                    else
                        tmpCount++;
                }

                //更改失败怎么办，返回false 再执行
                if (list != null && list.Count != tmpCount)
                {
                    return false;
                }
            }
            catch (System.Exception ex)
            {
                TextDocument.WriteFile(@"PMS/Log", "TaskError_", $"獲取下料點和更改庫位鎖定出錯，行為碼65053，{ex.Message}");
                return false;
            }
            

            return true;
        }

        /// <summary>
        /// 判断是否是pad调度任务，是的话不变更下料点
        /// </summary>
        /// <param name="TaskID"></param>
        /// <returns></returns>
        private bool JudgeIsPadTask(string TaskID)
        {
            SqlParameter[] parameters = new SqlParameter[]
            { 
                new SqlParameter("@TaskID",TaskID)
            };
            DataTable dt = DBHelper.ExecuteSelect("hp_JudgeIsPadTask", true, parameters);
            int result = System.Convert.ToInt32(dt.Rows[0][0]);
            if (result > 0)
                return true;
            else
                return false;
        }
    }
}
